subroutine CONSUMPTION_SIMULATION

use PARAM
use GLOBALS
use UTILS
use ULOC

implicit none

integer :: time, agent
real (long) :: local_value, local_MON_FREQ

real (long), dimension(variance_simulation_agents) :: stdev_agent, mean_agent

if (simulate_at_balanced_budget==1) then
    variance_PU(1)=U_0_HN 
    U_index=IULOC_H(U_0_HN)
else
    variance_PU(1)=Ugrid(U_index)
endif

variance_agent_state(0)=0 

do agent=1, variance_simulation_agents 
	do time=1, variance_simulation_time
		if (variance_agent_state(time-1)==1) then
			RELEVANT_element=c_MON_WW
			send_value=variance_PU(time)
			call interpolate_PU(send_value,local_value)
			variance_consumption(time)=local_value		
		else
			RELEVANT_element=c_MON
			send_value=variance_PU(time)
			call interpolate_PU(send_value,local_value)
			variance_consumption(time)=local_value
		endif
		if (variance_agent_state(time-1)==1) then 
			if (variance_unemployment_draw(agent,time)<etha) then				
				variance_agent_state(time)=1	
			else
				variance_agent_state(time)=0	
			endif			
			variance_PU(time+1)=variance_PU(time)			
		else 		
			if (variance_employment_draw(agent,time)<pi_a(effort_optimal(U_index,0))) then 
			    variance_agent_state(time)=1				
				RELEVANT_element=U_E
				send_value=variance_PU(time)
				call interpolate_PU(send_value,local_value)
				variance_PU(time+1)=local_value
			else 				
				RELEVANT_element=MON_FREQ
				call interpolate_PU(send_value,local_MON_FREQ)
				local_MON_FREQ=2
				if (variance_monitor_choice(agent,time)>local_MON_FREQ) then 
					variance_agent_state(time)=2				
					RELEVANT_element=U_NO_MON	
					send_value=variance_PU(time)
					call interpolate_PU(send_value,local_value)
					variance_PU(time+1)=local_value				 
				else 
					if (variance_monitor_result(agent,time)<theta_a_parameter) then 
						variance_agent_state(time)=3									
						RELEVANT_element=U_GOOD
						send_value=variance_PU(time)
						call interpolate_PU(send_value,local_value)
						variance_PU(time+1)=local_value
					else 
						variance_agent_state(time)=4									
						RELEVANT_element=U_BAD
						send_value=variance_PU(time)
						call interpolate_PU(send_value,local_value)
						variance_PU(time+1)=local_value
					endif 
				endif 
			endif 
		endif 
	enddo 
	do time=1,variance_simulation_time
	    variance_cons_data(agent,time)=variance_consumption(time)
	enddo
enddo

do agent=1,variance_simulation_agents
    stdev_agent(agent)= stdev(log(variance_cons_data(agent,:)),variance_simulation_time)
    mean_agent(agent)= sum((variance_cons_data(agent,:)))/variance_simulation_time
enddo
stdev_c_MON(variance_index)=sum(stdev_agent)/variance_simulation_agents
mean_c_MON(variance_index)=sum(mean_agent)/variance_simulation_agents
if (PC_run == 1) then
	open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\variance_cons_data.txt", position="rewind")
    write (9, *) variance_cons_data; close (UNIT=9)
else	
    open(unit=1, file="cons_data.txt")
	write (1, *) variance_cons_data; close (UNIT=1)
endif

endsubroutine CONSUMPTION_SIMULATION