subroutine CONSUMPTION_SIMULATION_HN

use PARAM
use GLOBALS
use UTILS

implicit none
integer :: agent, time
real (long) :: local_value, local_MON_FREQ
real (long), dimension(variance_simulation_agents) :: stdev_agent, mean_agent

if (simulate_at_balanced_budget==1) then
    variance_PU(1)=U_0_HN 
else
    variance_PU(1)=Ugrid(U_index)
endif
variance_agent_state(0)=0 
variance_consumption = 0
do agent=1,variance_simulation_agents 
    do time=1,variance_simulation_time-1
		if (variance_agent_state(time-1)==1) then
			RELEVANT_element=c_HN_WW
			send_value=variance_PU(time)
			call interpolate_PU(send_value,local_value)
			variance_consumption(time)=local_value		
		else
			RELEVANT_element=c_HN
			send_value=variance_PU(time)
			call interpolate_PU(send_value,local_value)
			variance_consumption(time)=local_value
		endif
    	if (variance_agent_state(time-1)==1) then 
		    if (variance_unemployment_draw(agent,time)<etha) then	
			    variance_agent_state(time)=1	
		    else
			    variance_agent_state(time)=0	
		    endif
		    variance_PU(time+1)=variance_PU(time)    		
	    else 
		    if (variance_employment_draw(agent,time)<pi_a(effort_optimal_HN(U_index,0))) then 
			    variance_agent_state(time)=1
			    RELEVANT_element=U_S
			    send_value=variance_PU(time)
			    call interpolate_PU(send_value,local_value)
			    variance_PU(time+1)=local_value
		    else     			
			    variance_agent_state(time)=2			
			    RELEVANT_element=U_F
			    send_value=variance_PU(time)
			    call interpolate_PU(send_value,local_value)
			    variance_PU(time+1)=local_value			 
		    endif 
	    endif 
    enddo 
    RELEVANT_element=c_HN
    send_value=variance_PU(time)
    call interpolate_PU(send_value,local_value)
    variance_consumption(time)=local_value
	if (agent==1) then
		open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\random_simulated_consumption_HN.txt", position="rewind")
		write (9, *) variance_consumption; close (UNIT=9)
	elseif (agent==2) then
		open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\random_simulated_consumption_HN2.txt", position="rewind")
		write (9, *) variance_consumption; close (UNIT=9)
	elseif (agent==3) then
		open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\random_simulated_consumption_HN3.txt", position="rewind")
		write (9, *) variance_consumption; close (UNIT=9)
	elseif (agent==4) then
		open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\random_simulated_consumption_HN4.txt", position="rewind")
		write (9, *) variance_consumption; close (UNIT=9)
	elseif (agent==5) then
		open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\random_simulated_consumption_HN5.txt", position="rewind")
		write (9, *) variance_consumption; close (UNIT=9)
	elseif (agent==6) then
		open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\random_simulated_consumption_HN6.txt", position="rewind")
		write (9, *) variance_consumption; close (UNIT=9)
	endif
	
	do time=1,variance_simulation_time
	    variance_cons_data(agent,time)=variance_consumption(time)
	enddo
enddo

do agent=1,variance_simulation_agents
    stdev_agent(agent)= stdev(log(variance_cons_data(agent,:)),variance_simulation_time)
    mean_agent(agent)= sum((variance_cons_data(agent,:)))/variance_simulation_time
enddo

stdev_c_HN(variance_index)=sum(stdev_agent)/variance_simulation_agents
mean_c_HN(variance_index)=sum(mean_agent)/variance_simulation_agents

open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\variance_cons_data_HN.txt", position="rewind")
write (9, *) variance_cons_data; close (UNIT=9)

open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\simulated_consumption_HN.txt", position="rewind")
write (9, *) variance_consumption; close (UNIT=9)

open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\PU_HN.txt", position="rewind")
write (9, *) variance_PU; close (UNIT=9)

endsubroutine CONSUMPTION_SIMULATION_HN