subroutine GRIDS

use PARAM
use GLOBALS
use UTILS

implicit none
save

integer :: iord,Uk,iU1,id1, i_precision
real(long) , dimension (ngp_U) :: zpoint

print *, 'Umin=', Umin, 'Umax=', Umax
if (IND_CHEBISHEV == 1) then 
	do Uk=1,ngp_U
		ZPOINT(Uk) = -COS( (2.*Uk - 1.)/(2.*ngp_U)*(3.1416))
		UPOINT(Uk) = ( ZPOINT(Uk) + 1. )*(Umax - Umin)/2.0 + Umin
		TVALUE(1,Uk) = 1.0
		TVALUE(2,Uk) = ZPOINT(Uk)
		do iord=3,CHEBORD+1
			TVALUE (iord,Uk) = 2.0*ZPOINT(Uk)*TVALUE(iord-1,Uk) - TVALUE(iord-2,Uk)		
		enddo
	enddo
	Ugrid = UPOINT
else
	do iU1 = 1,ngp_U
		Ugrid(iU1) = Umin + ((iU1 - 1.0)/(ngp_U - 1.))*(Umax - Umin)
	enddo
endif
do iU1 = 1,ngp_Ugraph
	Ugridgraph(iU1) = Umin + ((iU1 - 1.)/(ngp_Ugraph - 1.))*(Umax - Umin)
enddo
do id1 = 0,max_d
	dgridgraph(id1) = id1 
enddo
do i_effort=1,effort_grid_size
    effort_grid(i_effort) = min_effort_grid+(1.0*i_effort-1)/(effort_grid_size-1)*(max_effort_grid-min_effort_grid)
    effort = effort_grid(i_effort)
    lifetime_discounted_effort(i_effort) = (effort_grid(i_effort)*(1-bita*(1-separation))+bita*pi_a(effort)*e) /(((1-bita*(1-pi_a(effort)))*(1-bita*(1-separation))-bita*pi_a(effort)*bita*separation))
    lifetime_discounted_effort_e(i_effort) = (e+bita*separation*lifetime_discounted_effort(i_effort))/(1-bita*(1-separation))
enddo
do i_effort=1, effort_grid_size_emp
    effort_grid_emp(i_effort) = min_effort_grid_emp+(1.0*i_effort-1)/(effort_grid_size_emp-1)*(max_effort_grid_emp-min_effort_grid_emp)
enddo
do i_precision=1,precision_grid_size
    precision_grid(i_precision) = (i_precision-1)*1.00/(precision_grid_size-1)
enddo

endsubroutine GRIDS