subroutine SIM_PROG_ACTUAL_UI

use PARAM
use GLOBALS
use UTILS

implicit none

integer :: time, agent
real (long) :: fixed_con, utility, local_value, local_MON_FREQ, my_rand, planner_cost, average_utility
real (long) :: tax, sanction_rate, replacement_ratio, benefits, net_wage, net_benefits

sanction_rate=0.23
tax=0.29
replacement_ratio=0.50 
benefits=replacement_ratio*wage
net_benefits=benefits*(1-tax)
net_wage=wage*(1-tax)
do agent=1,simulation_agents
	utility=0
	planner_cost=0
	agent_state(0)=2
	do time=1,simulation_time 
		if (agent_state(time-1)==1) then 
			agent_state(time)=1	
		else 		
			if (employment_draw(agent,time)<pi_h(0)) then  
				agent_state(time)=1				
			else 
				agent_state(time)=3
			endif
		endif 
		if (agent_state(time)==4) then			
			consumption(time)=(1-sanction_rate)*net_benefits			
		elseif  (agent_state(time)==3) then			
			consumption(time)=net_benefits
		elseif  (agent_state(time)==1) then			
			consumption(time)=net_wage			
		else		    
		    stop
		endif
		planner_cost=planner_cost+consumption(time)*bita**(time-1)
		utility=utility+(UTIL(consumption(time))-e)*bita**(time-1)
		if (agent_state(time)==1) then
			planner_cost=planner_cost-wage*bita**(time-1)
		endif		
	enddo 
	do time=1,simulation_time
		cons_data(agent,time)=consumption(time)
	enddo
    agent_SIM_COST(agent)=planner_cost
    agent_utility(agent)=utility
enddo
average_act_cost=(SUM(agent_SIM_COST))/simulation_agents
average_utility=(SUM(agent_utility))/simulation_agents
target_average_utility=average_utility
if (PC_run == 1) then
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\average_act_UI_cost.txt", position="rewind")
    write (9, *) average_act_cost; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\average_UI_utility.txt", position="rewind")
    write (9, *) average_utility; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\consumption_ACT_UI.txt", position="rewind")
    write (9, *) consumption; close (UNIT=9)
    open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\sim_act_UI_cons_data.txt", position="rewind")
    write (9, *) cons_data; close (UNIT=9)
else
    open(unit=1, file="average_act_UI_cost.txt")
    write (1, *) average_act_cost; close (UNIT=1)
    open(unit=1, file="average_UI_utility.txt")
    write (1, *) average_utility; close (UNIT=1)
    open(unit=1, file="consumption_ACT_UI.txt")
    write (1, *) consumption; close (UNIT=1)
    open(unit=1, file="sim_act_UI_cons_data.txt")
    write (1, *) cons_data; close (UNIT=1)
endif

endsubroutine SIM_PROG_ACTUAL_UI