subroutine SIM_PROG_OPTIMAL

use PARAM
use GLOBALS
use UTILS

implicit none


integer :: time, agent
real (long) :: local_value, utility, local_MON_FREQ, planner_cost, average_utility

average_utility=target_average_utility*1.05
initial_PU=U_0_HN*1.25 

do WHILE (average_utility/target_average_utility>1.00001 .OR. average_utility/target_average_utility<0.99999)
    initial_PU=initial_PU/(average_utility/target_average_utility)
	do agent=1,simulation_agents	
		utility=0			
		planner_cost=0		
		PU(0)=initial_PU 
		agent_state(0)=2
		do time=1,simulation_time 
			if (agent_state(time-1)>1) then
				RELEVANT_element=c_MON
				send_value=PU(time-1)
				call interpolate_PU(send_value,local_value)
				consumption(time)=local_value
			elseif (agent_state(time-1)==1) then
				RELEVANT_element=c_MON_WW
				send_value=PU(time-1)
				call interpolate_PU(send_value,local_value)
				consumption(time)=local_value		
			endif
			if (agent_state(time-1)==1) then 
				agent_state(time)=1	
				RELEVANT_element=U_E
				send_value=PU(time-1)
				call interpolate_PU(send_value,local_value)
			    PU(time)=PU(time-1)				
			else 			
				if (employment_draw(agent,time)<pi_h(0)) then  
					agent_state(time)=1					
					RELEVANT_element=U_E
					send_value=PU(time-1)
					call interpolate_PU(send_value,local_value)
			   		PU(time)=local_value
				else 					
					RELEVANT_element=MON_FREQ
					send_value=PU(time-1)
					call interpolate_PU(send_value,local_MON_FREQ)
					if (monitor_choice(agent,time)>local_MON_FREQ) then 
						agent_state(time)=2					
						RELEVANT_element=U_NO_MON	
						send_value=PU(time-1)
						call interpolate_PU(send_value,local_value)
						PU(time)=local_value					 
					else 
						planner_cost=planner_cost+kapa_MON*bita**(time-1)
						if (monitor_result(agent,time)<theta_h) then 
							agent_state(time)=3										
							RELEVANT_element=U_GOOD
							send_value=PU(time-1)
							call interpolate_PU(send_value,local_value)
							PU(time)=local_value
						else 
							agent_state(time)=4										
							RELEVANT_element=U_BAD
							send_value=PU(time-1)
							call interpolate_PU(send_value,local_value)
							PU(time)=local_value
						endif 
					endif 
				endif 
			endif 
			planner_cost=planner_cost+consumption(time)*bita**(time-1)
			utility=utility+(UTIL(consumption(time))-e)*bita**(time-1)
			if (agent_state(time)==1) then
				planner_cost=planner_cost-wage*bita**(time-1)
			endif			
		enddo 
		do time=1,simulation_time
			cons_data_sim(agent,time)=consumption(time)
		enddo
		agent_SIM_COST(agent)=planner_cost
		agent_utility(agent)=utility
	enddo
	average_opt_cost=(SUM(agent_SIM_COST))/simulation_agents
	average_utility=(SUM(agent_utility))/simulation_agents
enddo
RELEVANT_element=c_MON
send_value=initial_PU
call interpolate_PU(send_value,local_value)
average_consumption=local_value
opt_act_savings=average_act_cost-average_opt_cost
opt_act_consumption_increase=opt_act_savings*(bita-1)/(bita**simulation_time-1)
opt_act_percent_consumption_increase=opt_act_consumption_increase/average_consumption
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\cons_data_SIM.txt", position="rewind")
write (9, *) cons_data_SIM; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\average_opt_cost.txt", position="rewind")
write (9, *) average_opt_cost; close (UNIT=9)
open (UNIT=9, file="F:\Users\ofers1\Documents\Visual Studio 2008\Projects\QE_Monitoring\QE_Monitoring\IO\"//experiment//"\consumption_OPT.txt", position="rewind")
write (9, *) consumption; close (UNIT=9)
initial_utility_in_actual_program = initial_PU

endsubroutine SIM_PROG_OPTIMAL